package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.PersonalAuthentication;
import com.izouma.awesomeadmin.service.PersonalAuthenticationService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/personalAuthentication")
@RequiresAuthentication
public class PersonalAuthenticationController {

    @Autowired
    private PersonalAuthenticationService personalAuthenticationService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(PersonalAuthentication record) {
        List<PersonalAuthentication> pp = personalAuthenticationService.getPersonalAuthenticationList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getPersonalAuthentication", method = RequestMethod.GET)
    @ResponseBody
    public Result getPersonalAuthentication(@RequestParam(required = false, value = "id") String id) {
        PersonalAuthentication data = personalAuthenticationService.getPersonalAuthenticationById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(PersonalAuthentication record) {
        PersonalAuthentication data = personalAuthenticationService.getPersonalAuthentication(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, PersonalAuthentication record) {
        Map<String, Object> result = new HashMap<>();

        List<PersonalAuthentication> pp = personalAuthenticationService.getPersonalAuthenticationByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(PersonalAuthentication record) {
        boolean num = personalAuthenticationService.createPersonalAuthentication(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updatePersonalAuthentication(PersonalAuthentication record) {
        boolean num = personalAuthenticationService.updatePersonalAuthentication(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deletePersonalAuthentication(@RequestParam(required = true, value = "id") String id) {

        boolean num = personalAuthenticationService.deletePersonalAuthentication(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, PersonalAuthentication record) throws Exception {

        List<PersonalAuthentication> personalAuthentications = personalAuthenticationService.getPersonalAuthenticationList(record);


        String sheetName = "personal_authentication";
        String titleName = "个人认证数据表";
        String fileName = "个人认证表";
        int columnNumber = 15;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "用户id", "用户名", "真实姓名", "身份证号", "正面", "背面", "状态", "电话", "备注"};
        String[][] dataList = new String[personalAuthentications.size()][15];

        for (int i = 0; i < personalAuthentications.size(); i++) {

            dataList[i][0] = String.valueOf(personalAuthentications.get(i).getId());
            dataList[i][1] = String.valueOf(personalAuthentications.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(personalAuthentications.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(personalAuthentications.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(personalAuthentications.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(personalAuthentications.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(personalAuthentications.get(i).getUserId());
            dataList[i][7] = String.valueOf(personalAuthentications.get(i).getUserName());
            dataList[i][8] = String.valueOf(personalAuthentications.get(i).getRealName());
            dataList[i][9] = String.valueOf(personalAuthentications.get(i).getIdcard());
            dataList[i][10] = String.valueOf(personalAuthentications.get(i).getFaceImage());
            dataList[i][11] = String.valueOf(personalAuthentications.get(i).getBackImage());
            dataList[i][12] = String.valueOf(personalAuthentications.get(i).getStatusFlag());
            dataList[i][13] = String.valueOf(personalAuthentications.get(i).getTelephone());
            dataList[i][14] = String.valueOf(personalAuthentications.get(i).getRemark());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }


    /**
     * <p>审核通过。</p>
     */
    @RequestMapping(value = "/pass", method = RequestMethod.POST)
    @ResponseBody
    public Result pass(PersonalAuthentication record) {
        boolean num = personalAuthenticationService.pass(record);
        if (num) {
            return new Result(true, "通过");
        }
        return new Result(false, "异常");
    }

    /**
     * <p>审核失败。</p>
     */
    @RequestMapping(value = "/fail", method = RequestMethod.POST)
    @ResponseBody
    public Result fail(PersonalAuthentication record) {
        boolean num = personalAuthenticationService.fail(record);
        if (num) {
            return new Result(true, "成功");
        }
        return new Result(false, "异常");
    }

}

